#include<stdio.h>
#include<obliv.h>
#include<stdlib.h>
#include<pthread.h>
//#include<gazelle.oc>
#include"gazelle.h"
void sereveprog(void *args)
{
  ProtocolDesc pd;
  Args *ref=args;
  if(protocolAcceptTcp2P(&pd,(*ref).port)!=0)
    { fprintf(stderr,"TCP accept failed\n");
      exit(1);
    }
  setCurrentParty(&pd,1);
  execYaoProtocol(&pd,gazelle,&(*ref).io);
  cleanupProtocol(&pd);
}
void clientprog(void *args)
{
  ProtocolDesc pd;
  Args *ref=args;
  if(protocolConnectTcp2P(&pd,(*ref).remote_host,(*ref).port)!=0)
    { fprintf(stderr,"TCP connect failed\n");
      exit(1);
    }
  setCurrentParty(&pd,2);
  execYaoProtocol(&pd,gazelle,&(*ref).io);
  cleanupProtocol(&pd);
}
extern "C"
{
int garble()
{
 // helib();
  /*ProtocolDesc pd;
  ProtocolIO io;
  if(argc!=5&&argc!=6)
  {
    fprintf(stderr,"Usage: %s <port> <proto> <--|server> <cx|sx> [<sy>] \n",argv[0]);
    return 1;
  }

  if(argc==5)
  {
    io.pcs=true;
    io.n1=atoi(argv[4]);
    io.n2=0;
  }
  else
  {
    io.pcs=false;
    io.n1=atoi(argv[4]);
    io.n2=atoi(argv[5]);
  }

  //protocolUseStdio(&pd);
  const char* remote_host = (strcmp(argv[3],"--")==0?NULL:argv[3]);
  ocTestUtilTcpOrDie(&pd,remote_host,argv[1]);

  setCurrentParty(&pd,(remote_host?2:1));
  if(!strcmp("yao",argv[2])) execYaoProtocol(&pd,gazelle,&io);
  else execNpProtocol_Bcast1(&pd,gazelle,&io);
  fprintf(stderr,"Result: %d\n",io.res);
  cleanupProtocol(&pd);
  return 0;*/
  long cx[MAXNUM],P,nu,sx[MAXNUM],sy[MAXNUM];
  //test assign
  nu=2;
  P=50;
  cx[0]=35;
  sx[0]=5;
  sy[0]=4;
  cx[1]=35;
  sx[1]=5;
  sy[1]=4;
  //test assign
  int i;
  ProtocolIO clio;
  ProtocolIO svio;
  for(i=0;i<nu;i++)
  {
    clio.p1[i]=cx[i];
    svio.p1[i]=sx[i];
    svio.p2[i]=sy[i];
  }
  clio.p1num=nu;
  clio.p2num=0;
  svio.p1num=nu;
  svio.p2num=nu;
  clio.P=P;
  svio.P=P;
  pthread_t client;
  pthread_t sereve;


  Args sv;
  sv.io=svio;
  sv.port="5000";

  Args cl;
  cl.io=clio;
  cl.remote_host="127.0.0.1";
  cl.port="5000";

  if (pthread_create(&sereve,NULL, sereveprog, &sv) == -1)
    printf("////sereve create thread faild");
  if (pthread_create(&client,NULL, clientprog, &cl) == -1)
    printf("////client create thread faild");

  void *res;
  pthread_join(sereve, &res);
  pthread_join(client, &res);
  printf("sereve result:\n");
  for(i=0;i<nu;i++)
    printf("%ld \n",sv.io.res[i]);
  printf("\n");
  printf("client result:\n");
  for(i=0;i<nu;i++)
    printf("%ld \n",cl.io.res[i]);
  printf("\n");
  return 0;
}
}
